

g_PREF_SUPPORT_INITED = false
--̻ ߰ ȵ
g_SYSTEM_SCRIPT_LOADED = include("system.lua") and include("class.lua") and include("db.lua")

include("dialog_handler.lua")

systemOS = string.lower( ___getenv( "System.OS" , "" ) )

if not g_SYSTEM_SCRIPT_LOADED or not g_PREF_SUPPORT_INITED then	
	_T = function( key )
		return key
	end
else
	if DB.GetLocaleFont then
		g_localeFont = DB.GetLocaleFont()
	end
end

string.split = function( str, pattern )
	local tempstr = str
	local res = {};

	local plegth = string.len( pattern )

	function makepattern( p1 )
		if p1 == "." 
			or p1 == "^"
		then
			return "%"..p1
		end

		return p1
	end

	pattern = makepattern( pattern )

	while true do
		local temp = string.find( tempstr, pattern );
		local cur = ""
		if temp == nil then
			cur = tempstr
			table.insert( res ,  cur )
			break;
		else
			cur = string.sub( tempstr, 0, temp - 1 )
			table.insert( res ,  cur )
		end
		
		tempstr = string.sub( tempstr, string.len( cur ) + plegth + 1, string.len( tempstr ));

		if string.len( tempstr ) <= 0 then
			break;
		end
	end
	return res;
end

if not launcher_input then
	launcher_input = {}
end

launcher_input.Init = function( self )
	self._inputSystem = InputSystem( self )
end
launcher_input.Fini = function( self )
	self._inputSystem = nil
	collectgarbage("collect")
end

launcher_input.OnTouchPress = function( self , serial , x , y , idx , cnt )
	if 0 == idx then
		self._touchCount		= ( self._touchCount or 0 ) + 1
		self._mouseX 			= x
		self._mouseY 			= y	
		self:OnTouchMove( serial, x, y, idx, cnt )
		UIManager:InjectKey( "ML" , true )
	end	
end

launcher_input.OnTouchRelease = function( self , serial ,x , y , idx , cnt )
	if 0 == idx then
		self._mouseX 			= x
		self._mouseY 			= y
		self:OnTouchMove( serial, x, y, idx, cnt )
		UIManager:InjectKey( "ML" , false )
	end	
end

launcher_input.OnTouchMove = function( self , serial ,x , y , idx , cnt )
	if self._mouseX and self._mouseY then
		local mouse = MouseData()
		mouse:SetAxisX( x , x-self._mouseX )
		mouse:SetAxisY( y , y-self._mouseY )
		mouse:SetAxisZ( 0 , 0 )
		UIManager:InjectMouse( mouse )
	end
	self._mouseX = x
	self._mouseY = y
end

launcher_input.HasTouchCount = function( self )
	return self._touchCount and self._touchCount > 0
end

launcher_input.ResetTouchCount = function( self )	
	self._touchCount = 0
end
		


		
function ShowLaunchLogo()
	
	local function _LcFadeIn()
		UI.m_lunch_fade.Alpha = 0
		UI.m_lunch_fade.Show = true
		
		local fFadeTime = 1
		local fFlowTime = 0
		
		while fFadeTime > fFlowTime and not launcher_input:HasTouchCount()  do
			fFlowTime = fFlowTime + TIME_PER_FRAME
			UI.m_lunch_fade.Alpha = math.min( 1 , fFlowTime / fFadeTime )
			coroutine.yield()
		end	
		UI.m_lunch_fade.Alpha = 1
		coroutine.yield()
	end
	
	local function _LcFadeOut()
		UI.m_lunch_fade.Alpha = 1
		local fFadeTime = 0.5
		local fFlowTime = 0
		
		while fFadeTime > fFlowTime and not launcher_input:HasTouchCount() do
			fFlowTime = fFlowTime + TIME_PER_FRAME
			UI.m_lunch_fade.Alpha = math.max( 0, 1 - ( fFlowTime / fFadeTime ) )
			coroutine.yield()
		end			
		UI.m_lunch_fade.Show = false
		local fFadeTime = 1.0
		local fFlowTime = 0
		
		while fFadeTime > fFlowTime and not launcher_input:HasTouchCount() do
			fFlowTime = fFlowTime + TIME_PER_FRAME
			coroutine.yield()
		end
		coroutine.yield()
	end
	
	local result = string.split(  ___getenv( "app.launch.logo" , "" ) , "," )
	
	local function checkOs( s )		
		if "-" == string.sub( s, 1 , 1 ) then
			return string.sub( s, 2 ) ~= systemOS
		elseif "+" == string.sub( s, 1 , 1 ) then
			return string.sub( s, 2 ) == systemOS
		end
		return s == systemOS
	end
	
	local index = 1
	for _ , file in pairs( result ) do
		local info = string.split( file , "_" )
		info[3] = string.gsub( info[3] or "white" , ".png" , "" )
		info[4] = string.gsub( info[4] or "all" , ".png" , "" )
		
		if not info[4] or "all" == info[4] or checkOs( info[4] ) then
			launcher_input:ResetTouchCount()				
			local bgcolor = info[3] or "white"
			ShowRectImage( file , "1280x720" , "dot_" .. bgcolor .. ".png" )
			_LcFadeOut()
			if index < table.maxn( result ) then
				_LcFadeIn()
				index = index + 1
			end
		end
	end
	HideRectImage()
	UI.m_lunch_fade.Show = false
end

function PlayIntroMovie()
--[[
	g_videoPlayer = GameSystem:CreateVideoClip( "video" )
	g_videoPlayer:Play( "mom_logo_01.ogv" , false )
	g_soundItem = SoundManagerImpl:CreateSoundByFile( "mom_logo_01.mp3" , false )
	if g_soundItem then
		g_soundItem:Play()
	end
	coroutine.yield()
	local skipTimeOver = false
	while g_videoPlayer.isPlaying do
		
		if not skipTimeOver then
			if g_videoPlayer.timePosition > 3 then
				launcher_input:ResetTouchCount()
				skipTimeOver = true
			end
		else
			if launcher_input:HasTouchCount() then
				break
			end
		end		
		coroutine.yield()
	end
	if g_soundItem then
		g_soundItem:Stop()
	end
	g_videoPlayer 	= nil
	g_soundItem 	= nil
--]]	
	collectgarbage("collect")
	G_LAUNCH_MOM_LOGO = true
	ShowRectImage( ___getenv( "app.title.logo" , "mom_logo_02.png" ) , "width" , "dot_black_lc.png" )
--[[	
	g_soundItem = SoundManagerImpl:CreateSoundByFile( "mom_logo_02.mp3" , true )
	if g_soundItem then
		g_soundItem:Play()
	end
	g_videoPlayer:Play( "mom_logo_02.ogv" , true )
--]]	
end

function Log_run()
	local tm = tostring( ___gmtime() )
	___setenv( "Launcher.runtime", tm )
	local deviceID = ___getenv( "Launcher.identity", "" )
	if deviceID == "" then deviceID = "null" end	
	local ad_ID = ___getenv( "Launcher.identity2", "" )	
	
	local imei = ___getenv( "System.imei", "" )
	if imei == "" then imei = "null" end	
	local model = ___getenv( "Launcher.machine", "" )
	local system_os = ___getenv( "System.OS", "" )
	local locale = ___getenv( "System.Locale", "" )
	if locale == "" then locale = "null" end
	local Timezone = ___getenv( "System.Timezone", "" )
	if Timezone == "" then Timezone = "null" end
	local Timezone_offset = ___getenv( "System.Timezone_offset", "" )
	if Timezone_offset == "" then Timezone_offset = "null" end

	local install_time = ___getenv( "app.install_time", "" )
	if install_time == "" then install_time = "null" end
	local game_ver  = ___getenv( "app.version", "" )
	if game_ver == "" then game_ver  = "null" end
	local patch_ver  = ___getenv( "patch.version", "" )
	if patch_ver == "" then patch_ver  = "null" end
	local res_type  = ___getenv( "app.texture.resolution", "" )
	if res_type == "" then res_type  = "null" end

	GameNetImpl:Post( "init", { tm = tostring( tm ), device_id = deviceID}, true )
	GameNetImpl:Post( "app_log/run", { tm = tostring( tm ), device_info = { device_id = deviceID, ad_id = ad_ID, imei = imei, model = model, os = system_os, locale = locale, timezone = Timezone, timezone_offset = Timezone_offset }, clinet_info = { install_time = install_time, game_ver = game_ver, patch_ver = patch_ver, res_type = res_type } }, true )
end


function RequestServiceURL()

	
	local param 	= 
	{
		device_info = 
		{
			model 		= ___getenv( "Launcher.machine" , "" ) ,
			os 			= ___getenv( "System.OS" , "" ) ,
			locale 		= ___getenv( "System.Locale" , "" ) ,
			device_id	= ___getenv( "Launcher.identity" , "" ) , 
		} ,
		client_info =
		{
			market			= ___getenv( "app.market" ,"" ) ,
			install_time	= ___getenv( "app.install_time" ,"" ) ,
			game_ver 		= ___getenv( "app.version" , "0" ) ,
			patch_ver 		= ___getenv( 'patch.version', "0" ) ,
			res_type 		= ___getenv( "app.texture.resolution" , "" ) ,			
		} 		
	}

	
	function CallPrefInitServiceURLComplete()
		
		PrefInitServiceURLComplete = nil			
		if _SERVICE_ERROR_MSG then 
			if "upgrade" == _SERVICE_ERROR_FORWARD_URL then				
				error_confirm_handler.forwardURL = ___getenv( "app.upgrade_url" , "http://" ) 
				error_confirm_handler:Show( getTEXT( 'txtid_this_application_is_too_old_touch_to_update' ) )
			else
				error_confirm_handler.forwardURL = _SERVICE_ERROR_FORWARD_URL
				error_confirm_handler:Show( _SERVICE_ERROR_MSG )
			end			
		else	
			if "false" == ___getenv( "app.launcher" , "true" ) then
				LoadSecondaryResoure()
				UI.m_version.Show = true
				UI.m_version:UpdateVersion()
			else				
				UI.m_luncher.Show = true			
			end
		end
	end
	
	function OnResponseServiceURL( result )
	
		local function TrimString(s)
			return (string.gsub( tostring( s ) , "^%s*(.-)%s*$", "%1"))
		end				
		
		local function InitServiceURL( data )
			if not data then return end
			print( "patch.host" 			, TrimString( data.patch.host ) )
			print( "patch.port" 			, TrimString( data.patch.port ) )
			print( "patch.encrypt_uri" 		, TrimString( data.patch.encrypt_uri ) )
			print( "Launcher.requestURL" 	, TrimString( data.server.url ) )		
			
			___setenv( "patch.host" 			, TrimString( data.patch.host ) )
			___setenv( "patch.port" 			, TrimString( data.patch.port ) )
			___setenv( "patch.encrypt_uri" 		, TrimString( data.patch.encrypt_uri ) )
			___setenv( "Launcher.requestURL" 	, TrimString( data.server.url ) )		
		end
			
		if result.result then
			InitServiceURL( result.data )
			Log_run()				
			local data = result.data or {}
			if data.error and "" ~= data.error.msg then
				_SERVICE_ERROR_MSG 			= TrimString( data.error.msg )
				_SERVICE_ERROR_FORWARD_URL 	= TrimString( data.error.forward_url )
			else
				_SERVICE_ERROR_MSG = nil
				if "true" == ___getenv( "app.launcher" , "true" ) then
					check_version()				
				end			
			end
		else
			if result.msg ~= nil then
				local error_info = string.split( result.msg, ":" )
				if error_info[1] == "parsing_http_error_code" then
					_SERVICE_ERROR_MSG 		= getTEXT( error_info[1] ) .. error_info[2]
				else
					_SERVICE_ERROR_MSG 		= getTEXT( result.msg ) or getTEXT( "txtid_check_network" )
				end
			else
				_SERVICE_ERROR_MSG 		= getTEXT( "txtid_check_network" )
			end
			_SERVICE_ERROR_FORWARD_URL 	= nil
		end
		PrefInitServiceURLComplete = CallPrefInitServiceURLComplete
	end

	local versionURL = ___getenv( "app.approach_url" , "" )	
	if "" ~=  versionURL then		
		HTTPPost( versionURL , param , "OnResponseServiceURL" )
	else
		if "true" == ___getenv( "app.launcher" , "true" ) then
			check_version()				
		end
		PrefInitServiceURLComplete = CallPrefInitServiceURLComplete
	end
end


function PrefProcess()	
	if not _prefProcessInited then		
		_prefProcessInited = true
		RequestServiceURL()
		ShowLaunchLogo()
		PlayIntroMovie()
	end
	if PrefInitServiceURLComplete then
		PrefInitServiceURLComplete()		
	end
end

if not _launcherInited then

	_launcherInited = true	
	
	launcher_input:Init()
		
	UIManager:load_font( "default.ttf" , "default" )
	print( g_localeFont )
	if g_localeFont then
		UIManager:load_font( g_localeFont , "locale" )
	end
	
	UIManager:add_Dbm( "mom_luncher.pns" )
	UIManager:load_wnd( {name = "m_luncher" , show = false} )
	UIManager:load_wnd( {name = "m_lunch_fade" , show = false} )
	UIManager:load_wnd( {name = "last_confirm_lc" , show = false} )
	UIManager:load_wnd( {name = "m_version", show = false })
	
	UI.m_lunch_fade.SpriteName = "dot_white_lc"
	UI.m_lunch_fade.X 	 = 0
	UI.m_lunch_fade.Y 	 = 0
	UI.m_lunch_fade.Width  = UI.ScreenWidth
	UI.m_lunch_fade.Height = UI.ScreenHeight
	UI.m_lunch_fade.Show = true
	
end
