﻿
UI.m_luncher.on_Create = function( self )

	self.XScale = UI.ScreenWidth / self.Width
	self.YScale = UI.ScreenHeight / self.Height

	self.RETRY = 0

	self.CLIP_WIDTH = self.clip.Width

	self.gauge_file_loading_progress_lc.Alpha = 0.7

	UI.Print( "LAUNCHER INIT" )
	self.gauge_loading_progress_lc:LinkClipRegion( self.clip )
	UI.Print( self.clip.Width )

	self:setShow( false )
	self.logo.Show = true
	self.loading.Show = false
	self.error.Show = false		
	self.version.Show = false
	
	self.pre_patch_version = ""
	self.patch_start_time = 0

-- 임시
--	self.Mode = 'Update'
--	self:setLogo( 'bg_luncher_lc', 1 )
	self.LOADING_COUNT = 0
	self:SetTimer( 'Timer', 1 )
end

UI.m_luncher.setShow = function( self, flag )
	self.loading.Show = false
	self.logo.Show = flag
	--self.bg_luncher_lc.Show = flag
	self.eft_progress.Show = flag
	self.bg_loading_progress_lc.Show = flag
	self.gauge_loading_progress_lc.Show = flag
	self.gauge_file_loading_progress_lc.Show = flag
	self.gauge_blank.Show = flag
	self.eft_collection_progress_lc.Show = flag
	self.txt_info.Show = flag
	self.message.Show = flag
end

UI.m_luncher.on_Show = function( self )	
	self:setMode_Update()
end

UI.m_luncher.getAlpha = function( self, ratio )

	if ratio > 1 then ratio = 1 end

	if ratio < 0.2 then
		return ratio / 0.2
	elseif ratio < 0.8 then
		return 1
	else
		return ( ( 1 - ratio ) / 0.2 )
	end

end

UI.m_luncher.setMode_Logo1 = function( self )
	self.Mode = 'Logo1'
	self:setLogo( 'icon_snapdragon_logo2_lc', 0.2 )
end

UI.m_luncher.setMode_Logo2 = function( self )
	self.Mode = 'Logo2'
	self:setLogo( 'icon_zynga_logo_lc', 0.2 )
	self.Tick = UI.GetTickCount()
end

UI.m_luncher.setMode_Logo3 = function( self )
	self.Mode = 'Logo3'
	self:setLogo( 'icon_company_logo_lc', 0.2 )
	self.Tick = UI.GetTickCount()
end

UI.m_luncher.updateVersion = function( self )
	-- local str = '<size:17><right><#999999><shadow:1,1,3>'
	-- --[[
	-- str = str .. 'Game:' .. ___getenv( 'Launcher.requestURL', '' ) .. '    '
	-- str = str .. 'Patch:' .. ___getenv( 'update.ip', '' ) .. '    '
	-- --]]
	-- str = str .. 'Ver.' .. ___getenv( 'patch.version', '' ) .. '    '
	-- self.version.Caption = str
end

UI.m_luncher.setMode_Update = function( self )
	self.Mode = 'Update'
	--self:setLogo( 'bg_luncher_lc', 0.9 )
	--self.Sprite = 'dot_black_lc'
	self.Tick = UI.GetTickCount()
end

UI.m_luncher.procLogo1 = function( self, ratio )
	self.Alpha = self:getAlpha( ratio )

	if ratio >= 1 then
		self:setMode_Logo2()
	end
end

UI.m_luncher.procLogo2 = function( self, ratio )
	self.Alpha = self:getAlpha( ratio )

	if ratio >= 1 then
		self:setMode_Logo3()
	end
end

UI.m_luncher.procLogo3 = function( self, ratio )
	self.Alpha = self:getAlpha( ratio )

	if ratio >= 1 then
		self:setMode_Update()
	end
end


UI.m_luncher.procUpdate = function( self, ratio )
	self:setShow( true )
	self.Alpha = 1
	self.error.Show = true
	local progress = tonumber( ___getenv( 'patch.progress', '0' ) )
	self.clip.Width = self.CLIP_WIDTH * ( progress / 100 )
	--if progress == 100 then
	--	self.eft_collection_progress_lc.Show = false
	--else
	--	self.eft_collection_progress_lc.Show = true
	--	self.eft_collection_progress_lc.X = self.clip.X + self.clip.Width - self.eft_collection_progress_lc.Width / 2
	--end
	self.eft_collection_progress_lc.X = self.clip.X + self.clip.Width - self.eft_collection_progress_lc.Width / 2

	local detail_progress = tonumber( ___getenv( 'patch.download_size', '0' ) )
	self.gauge_file_loading_progress_lc.Width = self.Width * ( ( (detail_progress/100) % 100 ) / 100 )

	if ___getenv( 'patch.state', '' ) == 'query_complete' and self.Finished ~= true then
		___setenv( 'patch.state', '' )
		
		local network_status = ___get_network_status()
		

		if tonumber( ___getenv( 'patch.total_size', '0' ) ) > 1024*1024*400 then
			self.txt_info2.Caption = getTEXT( 'txtid_first_download' )
		end
		
		if network_status == "mobile" and 'true' ~= ___getenv( 'patch.ignore_wifi_check', '' ) then
			-- 와이파이가 없는 셀룰러 환경임. 
			wifi_confirm_handler.STATUS = "wifi"
			wifi_confirm_handler:Show()
		else
			start_download( '' )
		end
	elseif ___getenv( 'patch.state', '' ) == 'need_update_app' then
		___setenv( 'patch.state', '' )		
		wifi_confirm_handler.STATUS = "update"
		wifi_confirm_handler:Show()
	end
		
	-- TODO : update_app_url 로 가서 앱 업데이트 해야함.
	--ExternalIntfImpl:Query( "open.url" , { url = update_app_url }  )
		
	if ___getenv( 'patch.state', '' ) == 'complete' then
		if is_downloading_patch() then
			return
		end
		if self.Finished == nil then
			self.gauge_file_loading_progress_lc.Width = 0

			--패치 종료
			self:_patch_end()
			self.Finished = true
			finish_patch()
						
			self.Mode = 'Loading'
			--self.loading.Show = true
		end
	end
end

UI.m_luncher.procLoading = function( self, ratio )
	if self.START_GAME ~= true then	
		if not self.START_FILE_EXT_CACHE then
			self.START_FILE_EXT_CACHE = true
			___generate_file_ext_cache()
		end
		--run ___setenv( 'file_cache.state', 'complete' )
		if ___getenv( 'file_cache.state', '' ) == 'complete' then
			self:StartGame()
		else		
			local function replace_char( pos, str, r )
				return str:sub( 1 , pos-1 ) .. r .. str:sub( pos+1  )
			end		
			
			local pos = math.floor( GetTickCount() / 500 ) % 10 + 1
			local maxAniChar = 10			
			___setenv( "patch.message" , getTEXT( "txtid_Please_wait" ) .. replace_char( pos , string.rep( "." , maxAniChar ) , "♬" ) )
		end
	end
end

UI.m_luncher.setLogo = function( self, name, ratio )
--[[
	local w,h = UI:SpriteSize( name )
	local w_ratio = w/h

	self.logo.Sprite = name
	self.logo.Height = UI.ScreenHeight * ratio
	self.logo.Width = (w/h) * self.logo.Height
	self.logo.X = ( UI.ScreenWidth - self.logo.Width ) / 2
	self.logo.Y = ( UI.ScreenHeight - self.logo.Height ) / 2
--]]	
end

UI.m_luncher.on_Timer = function( self )

	if not self.Mode then return end

	-- 개발용
	if UI.re_download ~= nil and UI.re_download.Show == true then
		return
	end
	
	if  self.PENDING_FINISHTICK and ( UI.GetTickCount() - self.PENDING_FINISHTICK ) > 3000 then	
		___abort()
		return
	end
				
	self.Started = true

	if self.Tick == nil then
		self.Tick = UI.GetTickCount()
	end
	
	if self.STARTED == nil then
		self.STARTED = true
		--패치 시작
		self:_patch_start()
		self:StartPatch()
		self:updateVersion()
	end

	local str = ___getenv( 'patch.error', '' )
	local update_app_url = ___getenv( 'patch.update_app_url', '' )

	if ( update_app_url ~= '' ) and ___getenv( 'patch.state', '' ) ~= 'need_update_app' then
		___setenv( 'patch.progress', 0 )
		___setenv( 'patch.state', 'need_update_app' )				
	end
	
	local mode_ratio = ( UI.GetTickCount() - self.Tick ) / 3000
	self[ 'proc' .. self.Mode ]( self, mode_ratio )
	
	if update_app_url ~= '' then
		return
	end
		
	if str == '' then
		str = ___getenv( 'patch.message', '' )
		self.PrevError = ''
	else
		patch_error_confirm_handler:Show( getTEXT( str ) )
		--패치 실패
		--self:_patch_stop()
		if str == self.PrevError and update_app_url ~= '' then
			-- 5초 뒤 재시도
			if self.PrevErrorTime + 10000 < UI.GetTickCount() and self.RETRY < 20 then
				self:StartPatch()
				check_version()
			end
		else
			self.PrevError = str
			self.PrevErrorTime = UI.GetTickCount()
		end
	end

	if ___getenv( 'patch.state', '' ) == 'complete' then
		self:updateVersion()
	else
		if self.RETRY >= 2 then
			self.error.Caption = '<size:13><#ffffff><shadow:1,1,3>' .. getTEXT( "txtid_retry" ) .. self.RETRY
		end
		self.message.Caption = '<size:18><hcenter><vcenter><#ffffff><shadow:1,1,3>'.. getTEXT( str ) 
		--print("message:",CheckSplit( str ) )
	end
end

UI.m_luncher.version.on_MouseButton = function( self, from, msg )
	if msg.Down then
		if self.DebugCount == nil then
			self.DebugCount = 1
		else
			self.DebugCount = self.DebugCount + 1
		end

		if self.DebugCount >= 5 then
			self.DebugMode = true
		end
		UI.Print( self.DebugCount )
	end
end

UI.m_luncher.on_MouseButton = function( self, from, msg )

	if self.Started ~= true then
		return
	end

	if msg.Down then
		if self.Mode == 'Logo1' then
			self:setMode_Logo2()
			return
		elseif self.Mode == 'Logo2' then
			self:setMode_Update()
			return
		end
		
		if ___getenv( 'patch.error', '' ) ~= '' then
			--self.RETRY = 0
			--self.error.Caption = ''
			--self:StartPatch()
			--check_version()
		end
	end
end

UI.m_luncher.StartPatch = function( self )
	UI.Print( 'Retry...' )
	self.RETRY = self.RETRY + 1
	self.PrevError = ''
	self.PrevErrorTime = 0
	--check_version()
end

UI.m_luncher.StartGame = function( self )
	if self.START_GAME ~= true then
		self.START_GAME = true
		LoadSecondaryResoure()
		self:ReleaseSprite()
		self.Show = false
	end
end

UI.m_luncher._patch_start = function( self )
	local tm = tostring( ___gmtime() )
	self.patch_start_time = tm
	
	local deviceID = ___getenv( "Launcher.identity", "" )
	local runtime = ___getenv( "Launcher.runtime", "" )
	if deviceID == "" then deviceID = "null" end	
	local ad_ID = ___getenv( "Launcher.identity2", "" )	
	local imei = ___getenv( "System.imei", "" )
	if imei == "" then imei = "null" end	
	local model = ___getenv( "Launcher.machine", "" )
	local system_os = ___getenv( "System.OS", "" )
	local locale = ___getenv( "System.Locale", "" )
	if locale == "" then locale = "null" end
	local Timezone = ___getenv( "System.Timezone", "" )
	if Timezone == "" then Timezone = "null" end
	local Timezone_offset = ___getenv( "System.Timezone_offset", "" )
	if Timezone_offset == "" then Timezone_offset = "null" end
	
	local install_time = ___getenv( "app.install_time", "" )
	if install_time == "" then install_time = "null" end

	g_version.pre = {}
	
	local game_ver = ___getenv( "app.version", "" )
	if game_ver == "" then game_ver  = "null" end
	g_version.pre.version = game_ver
	
	local game_ver_name = ___getenv( "app.version_name", "" )
	if game_ver_name == "" then game_ver_name  = "null" end
	g_version.pre.version_name = game_ver_name

	local game_ver_code = ___getenv( "app.version_code", "" )
	if game_ver_code == "" then game_ver_code  = "null" end
	g_version.pre.version_code = game_ver_code
	
	self.pre_patch_version  = ___getenv( "patch.version", "" )
	if self.pre_patch_version == "" then self.pre_patch_version  = "null" end
	g_version.pre.version_patch = self.pre_patch_version
	
	local res_type  = ___getenv( "app.texture.resolution", "" )
	if res_type == "" then res_type  = "null" end

	UI.m_version.Show = true
	UI.m_version:UpdateVersion()
	
	print( "UI.m_luncher._patch_start" , game_ver, self.pre_patch_version )

	--GameLog:Add( "app_log/patch_start", { tm = tostring( tm ), runtime = runtime, device_info = { device_id = deviceID, ad_id = ad_ID, imei = imei, model = model, os = system_os, locale = locale, timezone = Timezone, timezone_offset = Timezone_offset }, client_info = { install_time = install_time, game_ver = game_ver, patch_ver = self.pre_patch_version, res_type = res_type } }, true )
	--GameLog:Add( "app_log/patch_start", { tm = tostring( tm ), device_id = deviceID, client_ver = client_ver, patch_ver = patch_ver, runtime = runtime, first_start_time = start_time }, true )
end

UI.m_luncher._patch_stop = function( self )
	local tm = tostring( ___gmtime() )
	local deviceID = ___getenv( "Launcher.identity", "" )
	if deviceID == "" then deviceID = "null" end	
	local runtime = ___getenv( "Launcher.runtime", "" )
	
	local imei = ___getenv( "System.imei", "" )
	if imei == "" then imei = "null" end	
	local model = ___getenv( "Launcher.machine", "" )
	local system_os = ___getenv( "System.OS", "" )
	local locale = ___getenv( "System.Locale", "" )
	if locale == "" then locale = "null" end
	local Timezone = ___getenv( "System.Timezone", "" )
	if Timezone == "" then Timezone = "null" end
	local Timezone_offset = ___getenv( "System.Timezone_offset", "" )
	if Timezone_offset == "" then Timezone_offset = "null" end

	local install_time = ___getenv( "app.install_time", "" )
	if install_time == "" then install_time = "null" end
	local game_ver = ___getenv( "app.version", "" )
	if game_ver == "" then game_ver  = "null" end
	local patch_ver  = ___getenv( "patch.version", "" )
	if patch_ver == "" then patch_ver  = "null" end
	local res_type  = ___getenv( "app.texture.resolution", "" )
	if res_type == "" then res_type  = "null" end
	
	--GameLog:Add( "app_log/patch_stop", { tm = tostring( tm ), runtime = runtime, device_info = { device_id = deviceID, imei = imei, model = model, os = system_os, locale = locale, timezone = Timezone, timezone_offset = Timezone_offset }, client_info = { install_time = install_time, game_ver = game_ver, patch_ver = patch_ver, res_type = res_type } }, true )
	--GameLog:Add( "app_log/patch_stop", { tm = tostring( tm ), device_id = deviceID, patch_ver = patch_ver, runtime = runtime }, true )
end

UI.m_luncher._patch_end = function( self )

	local tm = tostring( ___gmtime() )
	local deviceID = ___getenv( "Launcher.identity", "" )
	if deviceID == "" then deviceID = "null" end	
	local runtime = ___getenv( "Launcher.runtime", "" )
	
	local imei = ___getenv( "System.imei", "" )
	if imei == "" then imei = "null" end	
	local model = ___getenv( "Launcher.machine", "" )
	local system_os = ___getenv( "System.OS", "" )
	local locale = ___getenv( "System.Locale", "" )
	if locale == "" then locale = "null" end
	local Timezone = ___getenv( "System.Timezone", "" )
	if Timezone == "" then Timezone = "null" end
	local Timezone_offset = ___getenv( "System.Timezone_offset", "" )
	if Timezone_offset == "" then Timezone_offset = "null" end
	
	local install_time = ___getenv( "app.install_time", "" )
	if install_time == "" then install_time = "null" end

	local game_ver = ___getenv( "app.version", "" )
	if game_ver == "" then game_ver  = "null" end
	local patch_ver  = ___getenv( "patch.version", "" )
	if patch_ver == "" then patch_ver  = "null" end
	
	local res_type  = ___getenv( "app.texture.resolution", "" )
	if res_type == "" then res_type  = "null" end

	local total_size  = ___getenv( "patch.total_download_size", "" )
	if total_size == "" or total_size == "0" then total_size = "0" end
	
	local patch_time = tonumber( tm ) - tonumber( self.patch_start_time )
	print( "UI.m_luncher._patch_end" , game_ver, self.pre_patch_version, patch_ver, total_size, patch_time )

	--GameLog:Add( "app_log/patch_end", { tm = tostring( tm ), runtime = runtime, device_info = { device_id = deviceID, imei = imei, model = model, os = system_os, locale = locale, timezone = Timezone, timezone_offset = Timezone_offset }, client_info = { install_time = install_time, game_ver = game_ver, patch_ver = patch_ver, res_type = res_type }, patch_info = { pre_patch_ver = self.pre_patch_version, patch_ver = patch_ver, patch_time = patch_time, total_size = total_size } }, true )
	--GameLog:Add( "app_log/patch_end", { tm = tostring( tm ), device_id = deviceID, patch_ver = patch_ver, runtime = runtime }, true )

	UI.m_version:UpdateVersion()	
end

if not g_version then 
	g_version = {}
end
